DenseDoubleMatrix3D (Colt 1.2.0 - API Specification)
Keywords: cern.colt.matrix.impl.DenseDoubleMatrix3D class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Colt 1.2.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## cern.colt.matrix.impl
Class DenseDoubleMatrix3D

    java.lang.Object
      cern.colt.PersistentObject
          cern.colt.matrix.impl.AbstractMatrix
              cern.colt.matrix.impl.AbstractMatrix3D
                  cern.colt.matrix.DoubleMatrix3D
                      cern.colt.matrix.impl.DenseDoubleMatrix3D

All Implemented Interfaces:
  Cloneable, Serializable

public class DenseDoubleMatrix3D
extends DoubleMatrix3D

Dense 3-d matrix holding `double` elements. First see the package summary and javadoc tree view to get the broad picture.

Implementation:

Internally holds one single contigous one-dimensional array, addressed in (in decreasing order of significance): slice major, row major, column major. Note that this implementation is not synchronized.

Memory requirements:

`memory [bytes] = 8*slices()*rows()*columns()`. Thus, a 100*100*100 matrix uses 8 MB.

Time complexity:

`O(1)` (i.e. constant time) for the basic operations `get`, `getQuick`, `set`, `setQuick` and `size`,

Applications demanding utmost speed can exploit knowledge about the internal addressing. Setting/getting values in a loop slice-by-slice, row-by-row, column-by-column is quicker than, for example, column-by-column, row-by-row, slice-by-slice. Thus

       for (int slice=0; slice < slices; slice++) {
              for (int row=0; row < rows; row++) {
                 for (int column=0; column < columns; column++) {
                            matrix.setQuick(slice,row,column,someValue);
                     }
              }
       }

is quicker than

       for (int column=0; column < columns; column++) {
              for (int row=0; row < rows; row++) {
                 for (int slice=0; slice < slices; slice++) {
                            matrix.setQuick(slice,row,column,someValue);
                     }
              }
       }

Version:
  1.0, 09/24/99
See Also:
  Serialized Form

Field Summary

Fields inherited from class cern.colt.PersistentObject
`serialVersionUID`

Constructor Summary
`DenseDoubleMatrix3D(double[][][] values)` Constructs a matrix with a copy of the given values.
`DenseDoubleMatrix3D(int slices, int rows, int columns)` Constructs a matrix with a given number of slices, rows and columns.

Method Summary
`DoubleMatrix3D` | `assign(double[][][] values)` Sets all cells to the state specified by `values`.
`DoubleMatrix3D` | `assign(DoubleMatrix3D source)` Replaces all cell values of the receiver with the values of another matrix.
`double` | `getQuick(int slice, int row, int column)` Returns the matrix cell value at coordinate `[slice,row,column]`.
`DoubleMatrix3D` | `like(int slices, int rows, int columns)` Construct and returns a new empty matrix of the same dynamic type as the receiver, having the specified number of slices, rows and columns.
`void` | `setQuick(int slice, int row, int column, double value)` Sets the matrix cell at coordinate `[slice,row,column]` to the specified value.
`void` | `zAssign27Neighbors(DoubleMatrix3D B, Double27Function function)` 27 neighbor stencil transformation.

Methods inherited from class cern.colt.matrix.DoubleMatrix3D
`aggregate, aggregate, assign, assign, assign, cardinality, copy, equals, equals, get, getNonZeros, like, set, toArray, toString, viewColumn, viewColumnFlip, viewDice, viewPart, viewRow, viewRowFlip, viewSelection, viewSelection, viewSlice, viewSliceFlip, viewSorted, viewStrides, zSum`

Methods inherited from class cern.colt.matrix.impl.AbstractMatrix3D
`checkShape, checkShape, columns, rows, size, slices, toStringShort`

Methods inherited from class cern.colt.matrix.impl.AbstractMatrix
`ensureCapacity, trimToSize`

Methods inherited from class cern.colt.PersistentObject
`clone`

Methods inherited from class java.lang.Object
`getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### DenseDoubleMatrix3D

    public DenseDoubleMatrix3D(double[][][] values)

  Constructs a matrix with a copy of the given values. `values` is required to have the form `values[slice][row][column]` and have exactly the same number of rows in in every slice and exactly the same number of columns in in every row.

  The values are copied. So subsequent changes in `values` are not reflected in the matrix, and vice-versa.

Parameters:
  `values` - The values to be filled into the new matrix.
Throws:
  `IllegalArgumentException` - if `for any 1 <= slice < values.length: values[slice].length != values[slice-1].length`.
  `IllegalArgumentException` - if `for any 1 <= row < values[0].length: values[slice][row].length != values[slice][row-1].length`.

### DenseDoubleMatrix3D

    public DenseDoubleMatrix3D(int slices,
                               int rows,
                               int columns)

  Constructs a matrix with a given number of slices, rows and columns. All entries are initially `0`.

Parameters:
  `slices` - the number of slices the matrix shall have.
  `rows` - the number of rows the matrix shall have.
  `columns` - the number of columns the matrix shall have.
Throws:
  `IllegalArgumentException` - if `(double)slices*columns*rows > Integer.MAX_VALUE`.
  `IllegalArgumentException` - if `slices<0 || rows<0 || columns<0`.

Method Detail

### assign

    public DoubleMatrix3D assign(double[][][] values)

  Sets all cells to the state specified by `values`. `values` is required to have the form `values[slice][row][column]` and have exactly the same number of slices, rows and columns as the receiver.

  The values are copied. So subsequent changes in `values` are not reflected in the matrix, and vice-versa.

  Overrides:
    `assign` in class `DoubleMatrix3D`
  Parameters:
    `values` - the values to be filled into the cells.
  Returns:
    `this` (for convenience only).
  Throws:
    `IllegalArgumentException` - if `values.length != slices() || for any 0 <= slice < slices(): values[slice].length != rows()`.
    `IllegalArgumentException` - if `for any 0 <= column < columns(): values[slice][row].length != columns()`.

### assign

    public DoubleMatrix3D assign(DoubleMatrix3D source)

  Replaces all cell values of the receiver with the values of another matrix. Both matrices must have the same number of slices, rows and columns. If both matrices share the same cells (as is the case if they are views derived from the same matrix) and intersect in an ambiguous way, then replaces as if using an intermediate auxiliary deep copy of `other`.

  Overrides:
    `assign` in class `DoubleMatrix3D`
  Parameters:
    `source` - the source matrix to copy from (may be identical to the receiver).
  Returns:
    `this` (for convenience only).
  Throws:
    `IllegalArgumentException` - if `slices() != source.slices() || rows() != source.rows() || columns() != source.columns()`

### getQuick

    public double getQuick(int slice,
                           int row,
                           int column)

  Returns the matrix cell value at coordinate `[slice,row,column]`.

  Provided with invalid parameters this method may return invalid objects without throwing any exception. You should only use this method when you are absolutely sure that the coordinate is within bounds. Precondition (unchecked): `slice<0 || slice>=slices() || row<0 || row>=rows() || column<0 || column>=column()`.

  Specified by:
    `getQuick` in class `DoubleMatrix3D`
  Parameters:
    `slice` - the index of the slice-coordinate.
    `row` - the index of the row-coordinate.
    `column` - the index of the column-coordinate.
  Returns:
    the value at the specified coordinate.

### like

    public DoubleMatrix3D like(int slices,
                               int rows,
                               int columns)

  Construct and returns a new empty matrix of the same dynamic type as the receiver, having the specified number of slices, rows and columns. For example, if the receiver is an instance of type `DenseDoubleMatrix3D` the new matrix must also be of type `DenseDoubleMatrix3D`, if the receiver is an instance of type `SparseDoubleMatrix3D` the new matrix must also be of type `SparseDoubleMatrix3D`, etc. In general, the new matrix should have internal parametrization as similar as possible.

  Specified by:
    `like` in class `DoubleMatrix3D`
  Parameters:
    `slices` - the number of slices the matrix shall have.
    `rows` - the number of rows the matrix shall have.
    `columns` - the number of columns the matrix shall have.
  Returns:
    a new empty matrix of the same dynamic type.

### setQuick

    public void setQuick(int slice,
                         int row,
                         int column,
                         double value)

  Sets the matrix cell at coordinate `[slice,row,column]` to the specified value.

  Provided with invalid parameters this method may access illegal indexes without throwing any exception. You should only use this method when you are absolutely sure that the coordinate is within bounds. Precondition (unchecked): `slice<0 || slice>=slices() || row<0 || row>=rows() || column<0 || column>=column()`.

  Specified by:
    `setQuick` in class `DoubleMatrix3D`
  Parameters:
    `slice` - the index of the slice-coordinate.
    `row` - the index of the row-coordinate.
    `column` - the index of the column-coordinate.
    `value` - the value to be filled into the specified cell.

### zAssign27Neighbors

    public void zAssign27Neighbors(DoubleMatrix3D B,
                                   Double27Function function)

  27 neighbor stencil transformation. For efficient finite difference operations. Applies a function to a moving `3 x 3 x 3` window. Does nothing if `rows() < 3 || columns() < 3 || slices() < 3`.

      B[k,i,j] = function.apply(
         A[k-1,i-1,j-1], A[k-1,i-1,j], A[k-1,i-1,j+1],
         A[k-1,i,  j-1], A[k-1,i,  j], A[k-1,i,  j+1],
         A[k-1,i+1,j-1], A[k-1,i+1,j], A[k-1,i+1,j+1],

         A[k  ,i-1,j-1], A[k  ,i-1,j], A[k  ,i-1,j+1],
         A[k  ,i,  j-1], A[k  ,i,  j], A[k  ,i,  j+1],
         A[k  ,i+1,j-1], A[k  ,i+1,j], A[k  ,i+1,j+1],

         A[k+1,i-1,j-1], A[k+1,i-1,j], A[k+1,i-1,j+1],
         A[k+1,i,  j-1], A[k+1,i,  j], A[k+1,i,  j+1],
         A[k+1,i+1,j-1], A[k+1,i+1,j], A[k+1,i+1,j+1]
         )

      x x x -     - x x x     - - - -
      x o x -     - x o x     - - - -
      x x x -     - x x x ... - x x x
      - - - -     - - - -     - x o x
      - - - -     - - - -     - x x x

  Make sure that cells of `this` and `B` do not overlap. In case of overlapping views, behaviour is unspecified.

  Example:

      final double alpha = 0.25;
      final double beta = 0.75;

      cern.colt.function.Double27Function f = new cern.colt.function.Double27Function() {
         public final double apply(
            double a000, double a001, double a002,
            double a010, double a011, double a012,
            double a020, double a021, double a022,

            double a100, double a101, double a102,
            double a110, double a111, double a112,
            double a120, double a121, double a122,

            double a200, double a201, double a202,
            double a210, double a211, double a212,
            double a220, double a221, double a222) {
               return beta*a111 + alpha*(a000 + ... + a222);
            }
      };
      A.zAssign27Neighbors(B,f);

  Overrides:
    `zAssign27Neighbors` in class `DoubleMatrix3D`
  Parameters:
    `B` - the matrix to hold the results.
    `function` - the function to be applied to the 27 cells.
  Throws:
    `NullPointerException` - if `function==null`.
    `IllegalArgumentException` - if `rows() != B.rows() || columns() != B.columns() || slices() != B.slices()` .

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Colt 1.2.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Jump to the Colt Homepage